"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const domain = require("domain");
const uuid_1 = require("uuid");
class RequestContext {
    constructor(em) {
        this.em = em;
        this.id = uuid_1.v4();
    }
    static create(em, next) {
        const context = new RequestContext(em.fork());
        const d = domain.create();
        d.__mikro_orm_context = context;
        d.run(next);
    }
    static currentRequestContext() {
        return domain.active ? domain.active.__mikro_orm_context : undefined;
    }
    static getEntityManager() {
        const context = RequestContext.currentRequestContext();
        return context ? context.em : undefined;
    }
}
exports.RequestContext = RequestContext;
